<?php

/**
 * Description of AccessControlFilter
 *
 * @author oleksiy
 */
class AccessControlFilter extends CFilter {

    protected function preFilter($filterChain)
    {
        $sql = 'SELECT DISTINCT p.* FROM permissions p, users u, roles r, users_has_roles ur, roles_has_permissions rp
                WHERE p.id=rp.permissions_id
                    AND r.id=rp.roles_id
                    AND ur.roles_id=r.id
                    AND ur.users_id=u.id
                    AND u.id=:uid
                    AND p.controller=:controller
                    AND p.action=:action
                ORDER BY p.bizrule ASC';

        $command = Yii::app()->db->createCommand($sql);
        $command->bindParam(":uid", Yii::app()->user->id, PDO::PARAM_INT);
        $command->bindParam(":controller", $filterChain->controller->id, PDO::PARAM_STR);
        $command->bindParam(":action", $filterChain->action->id, PDO::PARAM_STR);
        $permissions = $command->queryAll();

        if(!empty($permissions)){
            foreach($permissions as $p){
                if(empty($p['bizrule']) || @eval($p['bizrule'])){
                    Yii::trace("Access to ".$controller->id."/".$action->id." for username ".Yii::app()->user->name." granted with permission '".$p['title']."' [ID:".$p['id']."]");
                    return true;
                }
            }
        }

        throw new CHttpException(401,Yii::t('yii','You are not authorized to perform this action.'));
        
    }

    protected function postFilter($filterChain)
    {
        // logic being applied after the action is executed
    }

}
?>
